function H = hog(I)

% n_rows = 28;
% n_cols = 28;
b_size = 4;
n_b_rows = 7;
n_b_cols = 7;

[Fx, Fy] = gradient(I);

n_ang_bins = 8;
edges = linspace(0,2*pi,n_ang_bins+1);

H = zeros(1,n_b_rows*n_b_cols*n_ang_bins);

for i = 1:n_b_rows
    for j = 1:n_b_cols
        row_offset = (i-1)*b_size;
        col_offset = (j-1)*b_size;
        Cx = Fx(row_offset+1:row_offset+b_size,col_offset+1:col_offset+b_size);
        Cy = Fy(row_offset+1:row_offset+b_size,col_offset+1:col_offset+b_size);
        hst = [];
        angs = [];
        for row = 1:b_size
            for col = 1:b_size
                xy = [Cx(row,col) Cy(row,col)];
                m = norm(xy);
                if m > 0
                    xy = xy./m;
                    a = ang(xy(1), xy(2));
                    angs = [angs a];
                end
            end
        end
        hst = histc(angs,edges);
        if isempty(hst)
            hst = zeros(1,n_ang_bins+1);
        end
        hst = hst(1:n_ang_bins);
        offset = ((i-1)*n_b_cols+(j-1))*n_ang_bins;
        H(offset+1:offset+n_ang_bins) = hst;
    end
end

end